<?php
/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 */
class m120411_124544_comments extends CDbMigration
{
    public function safeUp()
    {
        $this->createTable('{{comments}}', array(
            'id' => 'pk',
            'parent_id' => 'integer',
            'content_id' => 'string NOT NULL',
            'user_id' => 'integer',
            'moderator_email' => 'string',
            'firstname' => 'string',
            'lastname' => 'string',
            'email' => 'string NOT NULL',
            'subject' => 'string NOT NULL',
            'description' => 'text NOT NULL',
            'notify_moderator' => "bool NOT NULL DEFAULT FALSE",
            'notify_user' => "bool NOT NULL DEFAULT FALSE",
            'status' => "integer NOT NULL DEFAULT 0",
            'language' => 'string NOT NULL',
            'createtime' => 'timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP',
        ));
        $this->createIndex('comments_content_id_idx', '{{comments}}', 'content_id');
        $this->createIndex('comments_user_id_idx', '{{comments}}', 'user_id');
        $this->createIndex('comments_parent_id_idx', '{{comments}}', 'parent_id');
        $this->createIndex('comments_status_idx', '{{comments}}', 'status');

    }

    public function safeDown()
    {
        $this->dropTable('{{comments}}');
    }

}