<?php
/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 *
 * Widget, which contacts the Marketing Automation tracker to get and display
 * the current persona of the user.
 */
class MarkaPersonaInfoWidget extends BaseWidget
{    
    /**
     * The timeout (in seconds) for requests to the Marketing Automation tracker.
     * @var int 
     */
    private $markaRequestTimeoutSec = 10;
    
    
    /**
     * Contacts the Marketing Automation tracker to get the current persona
     * of the user and displays that information.
     * @return void
     */
    public function run()
    {
        $markaModule = Yii::app()->getModule('marketingautomation');
        $url = $markaModule->getMarkaTrackerBaseUrl() . '/v1/personas/';
        $url .= rawurlencode($markaModule->getUUID());
        $context = stream_context_create(array('http' => array('timeout' => $this->markaRequestTimeoutSec)));
        $responseJson = @file_get_contents($url, false, $context);
        $viewParams = array('personaInfo' => NULL);
        if ($responseJson !== false) {
            $responseObj = json_decode($responseJson);
            if (isset($responseObj->personaId)) {
                $viewParams = array('personaInfo' => $responseObj);
            }
        }
        $this->render('MarkaPersonaInfoWidget', $viewParams);
    }
    
}
