<?php
/**
 *
 */
class AccessControlFilter extends CAccessControlFilter {

    private $_rules = array();

    /**
     * returns verification rules
     *
     * @return array list of access rules.
     */
    public function getRules()
    {
        return $this->_rules;
    }

    /**
     * sets verification rules
     *
     * @param array $rules list of access rules.
     */
    public function setRules($rules)
    {
        foreach ($rules as $rule) {
            if (is_array($rule) && isset($rule[0])) {
                $r = new AccessRule;
                $r->allow = $rule[0]==='allow';
                foreach (array_slice($rule, 1) as $name => $value) {
                    if ($name==='expression' || $name==='roles' || $name==='message') {
                        $r->$name = $value;
                    } else {
                        $r->$name = array_map('strtolower', $value);
                    }
                }
                $this->_rules[] = $r;
            }
        }
    }
}
